1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
5
6# For repeatability, reset the environment to known value.
7LANG=C
8LC_ALL=C
9PAGER=cat
10TZ=UTC
11export LANG LC_ALL PAGER TZ
12EDITOR=:
13VISUAL=:
14unset GIT_EDITOR
15unset AUTHOR_DATE
16unset AUTHOR_EMAIL
17unset AUTHOR_NAME
18unset COMMIT_AUTHOR_EMAIL
19unset COMMIT_AUTHOR_NAME
20unset EMAIL
21unset GIT_ALTERNATE_OBJECT_DIRECTORIES
22unset GIT_AUTHOR_DATE
23GIT_AUTHOR_EMAIL=author@example.com
24GIT_AUTHOR_NAME='A U Thor'
25unset GIT_COMMITTER_DATE
26GIT_COMMITTER_EMAIL=committer@example.com
27GIT_COMMITTER_NAME='C O Mitter'
28unset GIT_DIFF_OPTS
29unset GIT_DIR
30unset GIT_WORK_TREE
31unset GIT_EXTERNAL_DIFF
32unset GIT_INDEX_FILE
33unset GIT_OBJECT_DIRECTORY
34unset SHA1_FILE_DIRECTORIES
35unset SHA1_FILE_DIRECTORY
36GIT_MERGE_VERBOSITY=5
37export GIT_MERGE_VERBOSITY
38export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
39export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
40export EDITOR VISUAL
41
42# Protect ourselves from common misconfiguration to export
43# CDPATH into the environment
44unset CDPATH
45
46case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
47 1|2|true)
48 echo "* warning: Some tests will not work if GIT_TRACE" \
49 "is set as to trace on STDERR ! *"
50 echo "* warning: Please set GIT_TRACE to something" \
51 "other than 1, 2 or true ! *"
52 ;;
53esac
54
55# Each test should start with something like this, after copyright notices:
56#
57# test_description='Description of this test...
58# This test checks if command xyzzy does the right thing...
59# '
60# . ./test-lib.sh
61
62[ "x$TERM" != "xdumb" ] &&
63 [ -t 1 ] &&
64 tput bold >/dev/null 2>&1 &&
65 tput setaf 1 >/dev/null 2>&1 &&
66 tput sgr0 >/dev/null 2>&1 &&
67 color=t
68
69test "${test_description}" != "" ||
70error "Test script did not set test_description."
71
72while test "$#" -ne 0
73do
74 case "$1" in
75 -d|--d|--de|--deb|--debu|--debug)
76 debug=t; shift ;;
77 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
78 immediate=t; shift ;;
79 -h|--h|--he|--hel|--help)
80 echo "$test_description"
81 exit 0 ;;
82 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
83 verbose=t; shift ;;
84 -q|--q|--qu|--qui|--quie|--quiet)
85 quiet=t; shift ;;
86 --no-color)
87 color=; shift ;;
88 --no-python)
89 # noop now...
90 shift ;;
91 *)
92 break ;;
93 esac
94done
95
96if test -n "$color"; then
97 say_color () {
98 case "$1" in
99 error) tput bold; tput setaf 1;; # bold red
100 skip) tput bold; tput setaf 2;; # bold green
101 pass) tput setaf 2;; # green
102 info) tput setaf 3;; # brown
103 *) test -n "$quiet" && return;;
104 esac
105 shift
106 echo "* $*"
107 tput sgr0
108 }
109else
110 say_color() {
111 test -z "$1" && test -n "$quiet" && return
112 shift
113 echo "* $*"
114 }
115fi
116
117error () {
118 say_color error "error: $*"
119 trap - exit
120 exit 1
121}
122
123say () {
124 say_color info "$*"
125}
126
127exec 5>&1
128if test "$verbose" = "t"
129then
130 exec 4>&2 3>&1
131else
132 exec 4>/dev/null 3>/dev/null
133fi
134
135test_failure=0
136test_count=0
137
138trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
139
140test_tick () {
141 if test -z "${test_tick+set}"
142 then
143 test_tick=1112911993
144 else
145 test_tick=$(($test_tick + 60))
146 fi
147 GIT_COMMITTER_DATE="$test_tick -0700"
148 GIT_AUTHOR_DATE="$test_tick -0700"
149 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
150}
151
152# You are not expected to call test_ok_ and test_failure_ directly, use
153# the text_expect_* functions instead.
154
155test_ok_ () {
156 test_count=$(expr "$test_count" + 1)
157 say_color "" " ok $test_count: $@"
158}
159
160test_failure_ () {
161 test_count=$(expr "$test_count" + 1)
162 test_failure=$(expr "$test_failure" + 1);
163 say_color error "FAIL $test_count: $1"
164 shift
165 echo "$@" | sed -e 's/^/ /'
166 test "$immediate" = "" || { trap - exit; exit 1; }
167}
168
169
170test_debug () {
171 test "$debug" = "" || eval "$1"
172}
173
174test_run_ () {
175 eval >&3 2>&4 "$1"
176 eval_ret="$?"
177 return 0
178}
179
180test_skip () {
181 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
182 this_test="$this_test.$(expr "$test_count" + 1)"
183 to_skip=
184 for skp in $GIT_SKIP_TESTS
185 do
186 case "$this_test" in
187 $skp)
188 to_skip=t
189 esac
190 done
191 case "$to_skip" in
192 t)
193 say_color skip >&3 "skipping test: $@"
194 test_count=$(expr "$test_count" + 1)
195 say_color skip "skip $test_count: $1"
196 : true
197 ;;
198 *)
199 false
200 ;;
201 esac
202}
203
204test_expect_failure () {
205 test "$#" = 2 ||
206 error "bug in the test script: not 2 parameters to test-expect-failure"
207 if ! test_skip "$@"
208 then
209 say >&3 "expecting failure: $2"
210 test_run_ "$2"
211 if [ "$?" = 0 -a "$eval_ret" != 0 -a "$eval_ret" -lt 129 ]
212 then
213 test_ok_ "$1"
214 else
215 test_failure_ "$@"
216 fi
217 fi
218 echo >&3 ""
219}
220
221test_expect_success () {
222 test "$#" = 2 ||
223 error "bug in the test script: not 2 parameters to test-expect-success"
224 if ! test_skip "$@"
225 then
226 say >&3 "expecting success: $2"
227 test_run_ "$2"
228 if [ "$?" = 0 -a "$eval_ret" = 0 ]
229 then
230 test_ok_ "$1"
231 else
232 test_failure_ "$@"
233 fi
234 fi
235 echo >&3 ""
236}
237
238test_expect_code () {
239 test "$#" = 3 ||
240 error "bug in the test script: not 3 parameters to test-expect-code"
241 if ! test_skip "$@"
242 then
243 say >&3 "expecting exit code $1: $3"
244 test_run_ "$3"
245 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
246 then
247 test_ok_ "$2"
248 else
249 test_failure_ "$@"
250 fi
251 fi
252 echo >&3 ""
253}
254
255# Most tests can use the created repository, but some amy need to create more.
256# Usage: test_create_repo <directory>
257test_create_repo () {
258 test "$#" = 1 ||
259 error "bug in the test script: not 1 parameter to test-create-repo"
260 owd=`pwd`
261 repo="$1"
262 mkdir "$repo"
263 cd "$repo" || error "Cannot setup test environment"
264 "$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
265 error "cannot run git init -- have you built things yet?"
266 mv .git/hooks .git/hooks-disabled
267 cd "$owd"
268}
269
270test_done () {
271 trap - exit
272 case "$test_failure" in
273 0)
274 # We could:
275 # cd .. && rm -fr trash
276 # but that means we forbid any tests that use their own
277 # subdirectory from calling test_done without coming back
278 # to where they started from.
279 # The Makefile provided will clean this test area so
280 # we will leave things as they are.
281
282 say_color pass "passed all $test_count test(s)"
283 exit 0 ;;
284
285 *)
286 say_color error "failed $test_failure among $test_count test(s)"
287 exit 1 ;;
288
289 esac
290}
291
292# Test the binaries we have just built. The tests are kept in
293# t/ subdirectory and are run in trash subdirectory.
294PATH=$(pwd)/..:$PATH
295GIT_EXEC_PATH=$(pwd)/..
296GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
297GIT_CONFIG=.git/config
298export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG
299
300GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
301export GITPERLLIB
302test -d ../templates/blt || {
303 error "You haven't built things yet, have you?"
304}
305
306if ! test -x ../test-chmtime; then
307 echo >&2 'You need to build test-chmtime:'
308 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
309 exit 1
310fi
311
312# Test repository
313test=trash
314rm -fr "$test"
315test_create_repo $test
316cd "$test"
317
318this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
319for skp in $GIT_SKIP_TESTS
320do
321 to_skip=
322 for skp in $GIT_SKIP_TESTS
323 do
324 case "$this_test" in
325 $skp)
326 to_skip=t
327 esac
328 done
329 case "$to_skip" in
330 t)
331 say_color skip >&3 "skipping test $this_test altogether"
332 say_color skip "skip all tests in $this_test"
333 test_done
334 esac
335done